# Generated by Django 2.2.17 on 2021-02-03 23:44

from django.db import migrations, models
import shortuuidfield.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='UserInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('user_id', shortuuidfield.fields.ShortUUIDField(blank=True, db_index=True, editable=False, help_text='用户唯一标识', max_length=22, null=True, unique=True)),
                ('unionid', models.CharField(blank=True, db_index=True, help_text='微信 Unionid', max_length=32, null=True, unique=True, verbose_name='unionid')),
                ('openid', models.CharField(blank=True, db_index=True, help_text='微信公众号 Openid', max_length=32, null=True, unique=True, verbose_name='openid')),
                ('openid_miniapp', models.CharField(blank=True, db_index=True, help_text='微信小程序 Openid', max_length=32, null=True, unique=True, verbose_name='openid_miniapp')),
                ('name', models.CharField(blank=True, help_text='用户姓名', max_length=255, null=True, verbose_name='name')),
                ('sex', models.IntegerField(choices=[(0, '未知'), (1, '男'), (2, '女')], default=0, help_text='用户性别', verbose_name='sex')),
                ('nickname', models.CharField(blank=True, help_text='用户昵称', max_length=255, null=True, verbose_name='nickname')),
                ('avatar', models.CharField(blank=True, help_text='用户头像', max_length=255, null=True, verbose_name='avatar')),
                ('phone', models.CharField(blank=True, db_index=True, help_text='用户电话', max_length=11, null=True, verbose_name='phone')),
                ('country', models.CharField(blank=True, help_text='用户国家', max_length=255, null=True, verbose_name='country')),
                ('province', models.CharField(blank=True, help_text='用户省份', max_length=255, null=True, verbose_name='province')),
                ('city', models.CharField(blank=True, help_text='用户城市', max_length=255, null=True, verbose_name='city')),
                ('user_status', models.IntegerField(choices=[(0, '未验证'), (1, '已激活'), (2, '已禁用'), (3, '已删除'), (10, '已分配')], default=0, help_text='用户状态', verbose_name='user_status')),
            ],
            options={
                'verbose_name': '用户信息',
                'verbose_name_plural': '用户信息',
            },
        ),
    ]
