# -*- coding: utf-8 -*-

from __future__ import division

from django.conf import settings
from django_response import response
from pywe_qrcode import qrcode_limit_str_scene, qrcode_url
from pywe_storage import RedisStorage

from utils.error.errno_utils import ParamStatusCode
from utils.redis.connect import r


def get_limit_scene_qrcode_url(request):
    scene = str(request.GET.get('scene', ''))

    if not scene:
        return response(ParamStatusCode.PARAM_NOT_FOUND)

    JSAPI = settings.WECHAT.get('JSAPI', {})

    appid = JSAPI.get('appID', '')
    appsecret = JSAPI.get('appsecret', '')

    qrinfo = qrcode_limit_str_scene(scene_str=scene, appid=appid, secret=appsecret, storage=RedisStorage(r))
    qrurl = qrcode_url(qrinfo.get('ticket'))

    return response(data={
        'qrurl': qrurl,
    })


def get_course_field_limit_scene_qrcode_url(scene):
    if not scene:
        return ''

    JSAPI = settings.WECHAT.get('JSAPI', {})

    appid = JSAPI.get('appID', '')
    appsecret = JSAPI.get('appsecret', '')

    qrinfo = qrcode_limit_str_scene(scene_str=scene, appid=appid, secret=appsecret, storage=RedisStorage(r))
    qrurl = qrcode_url(qrinfo.get('ticket'))

    return qrurl
