# Generated by Django 2.2.17 on 2021-02-03 22:02

from django.db import migrations, models
import jsonfield.fields
import shortuuidfield.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='BranchCampusAdministratorInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('admin_id', shortuuidfield.fields.ShortUUIDField(blank=True, db_index=True, editable=False, help_text='管理员唯一标识', max_length=22, null=True, unique=True)),
                ('campus_id', models.CharField(blank=True, db_index=True, help_text='分院唯一标识', max_length=32, null=True, verbose_name='campus_id')),
                ('campus_name', models.CharField(blank=True, help_text='分院名称', max_length=255, null=True, verbose_name='campus_name')),
                ('name', models.CharField(blank=True, help_text='管理员姓名', max_length=255, null=True, verbose_name='name')),
                ('phone', models.CharField(blank=True, db_index=True, help_text='管理员电话', max_length=11, null=True, verbose_name='phone')),
                ('user_status', models.IntegerField(choices=[(0, '待审核'), (1, '已激活'), (2, '已禁用'), (3, '已删除')], db_index=True, default=0, help_text='管理员状态', verbose_name='user_status')),
            ],
            options={
                'verbose_name': '分院管理员信息',
                'verbose_name_plural': '分院管理员信息',
            },
        ),
        migrations.CreateModel(
            name='BranchCampusInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('campus_id', shortuuidfield.fields.ShortUUIDField(blank=True, db_index=True, editable=False, help_text='分院唯一标识', max_length=22, null=True, unique=True)),
                ('campus_name', models.CharField(blank=True, help_text='分院名称', max_length=255, null=True, verbose_name='campus_name')),
            ],
            options={
                'verbose_name': '分院信息',
                'verbose_name_plural': '分院信息',
            },
        ),
        migrations.CreateModel(
            name='CourseInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('course_id', shortuuidfield.fields.ShortUUIDField(blank=True, db_index=True, editable=False, help_text='课程唯一标识', max_length=22, null=True, unique=True)),
                ('course_name', models.CharField(blank=True, help_text='课程名称', max_length=255, null=True, verbose_name='course_name')),
            ],
            options={
                'verbose_name': '课程信息',
                'verbose_name_plural': '课程信息',
            },
        ),
        migrations.CreateModel(
            name='CourseRegisterFieldInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('field_id', shortuuidfield.fields.ShortUUIDField(blank=True, db_index=True, editable=False, help_text='字段唯一标识', max_length=22, null=True, unique=True)),
                ('course_id', models.CharField(blank=True, db_index=True, help_text='课程唯一标识', max_length=32, null=True, verbose_name='course_id')),
                ('course_name', models.CharField(blank=True, help_text='课程名称', max_length=255, null=True, verbose_name='course_name')),
                ('fields', jsonfield.fields.JSONField(blank=True, default=[], help_text='字段列表', null=True, verbose_name='fields')),
            ],
            options={
                'verbose_name': '课程报名字段信息',
                'verbose_name_plural': '课程报名字段信息',
            },
        ),
        migrations.CreateModel(
            name='CourseRegisterInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.BooleanField(default=True, help_text='Status', verbose_name='status')),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Create Time', verbose_name='created_at')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Update Time', verbose_name='updated_at')),
                ('field_id', models.CharField(blank=True, db_index=True, help_text='字段唯一标识', max_length=32, null=True, verbose_name='field_id')),
                ('course_id', models.CharField(blank=True, db_index=True, help_text='课程唯一标识', max_length=32, null=True, verbose_name='course_id')),
                ('course_name', models.CharField(blank=True, help_text='课程名称', max_length=255, null=True, verbose_name='course_name')),
                ('fields', jsonfield.fields.JSONField(blank=True, default=[], help_text='字段信息', null=True, verbose_name='fields')),
            ],
            options={
                'verbose_name': '课程报名信息',
                'verbose_name_plural': '课程报名信息',
            },
        ),
    ]
